import { world, system } from "@minecraft/server";

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('g_rusty_copper_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function rustycopperamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_copper_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function copperamulet1");
e.source.runCommand("function copperamulet2");
e.source.runCommand("function copperamulet3"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_gold_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function goldamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_diamond_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function diamondamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_flight_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function flightamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_light_amulet:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_explosive_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function explosiveamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_fish_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function fishamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_pyschic_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function psychicamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_crucifix_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function crucifixamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_tunneler_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function tunneleramulet1");
e.source.runCommand("function tunneleramulet2"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_heart_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function heartamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_magnet_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function magnetamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_soul_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function soulamulet1");
e.source.runCommand("function soulamulet2"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_bloodlust_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function bloodlustamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_experience_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function experienceamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_fire_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function fireamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_gamebreaker_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function gamebreakeramulet1"); },
  onUseOn: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function gamebreakeramulet2"); },
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_beserker_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function beserkeramulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_firework_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function fireworkamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_evocationer_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function evocationeramulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_earth_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function earthamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_netherite_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function netheriteamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_weather_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function weatheramulet1"); },
  onUseOn: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function weatheramulet2"); },
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_creaking_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function creakingamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_moon_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function moonamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_sun_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function sunamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_amulet_of_starters:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amuletofstarters1");
e.source.runCommand("function amuletofstarters2"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_eclipse_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function eclipseamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_neutralizer_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function neutralizeramulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_eye_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function eyeamulet1");
e.source.runCommand("function eyeamulet2"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_cloning_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function cloningamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_sharp_crystal_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function sharpcrystalamulet1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function sharpcrystalamulet2"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_order_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function orderamulet1");
e.source.runCommand("function orderamuletrandom"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_order_amulet_redstone:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function redstoneorder1");
e.source.runCommand("function allorder1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_order_amulet_diamond:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function diamondorder1");
e.source.runCommand("function allorder1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_order_amulet_emerald:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function allorder1");
e.source.runCommand("function emeraldorder1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_order_amulet_iron:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function allorder1");
e.source.runCommand("function ironorder1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_order_amulet_lapis:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function allorder1");
e.source.runCommand("function lapisorder1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('g_knockback_amulet:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function knockbackamulet1");
e.source.runCommand("function knockbackamulet2"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});
 });
